// ----------------------------------------------------------------------- //
//
// MODULE  : RiotWeapons.h
//
// PURPOSE : Riot Weapons - Definitions of the Riot weapon classes
//
// CREATED : 9/30/97
//
// ----------------------------------------------------------------------- //

#ifndef __RIOT_WEAPONS_H__
#define __RIOT_WEAPONS_H__

#include "Weapon.h"

class CProjectile;

// Mecha weapons...

class CPulseRifle : public CWeapon
{
	public :
		CPulseRifle();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CRiotCannon : public CWeapon
{
	public :
		CRiotCannon();
};

class CPulseLauncher : public CWeapon
{
	public :
		CPulseLauncher();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CMassDriver : public CWeapon
{
	public :
		CMassDriver();
	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CDeathCharge : public CWeapon
{
	public :
		CDeathCharge();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CLithKiller : public CWeapon
{
	public :
		CLithKiller();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CSniperRifle : public CWeapon
{
	public :
		CSniperRifle();
};

class CBuzzsaw : public CWeapon
{
	public :
		CBuzzsaw();
};

class CAxe : public CWeapon
{
	public :
		CAxe();
};

class CHealGun : public CWeapon
{
	public :
		CHealGun();
};

class CSickGun : public CWeapon
{
	public :
		CSickGun();
};

class CBlinder : public CWeapon
{
	public :
		CBlinder();
};

class CShoulderCannons : public CWeapon
{
	public :
		CShoulderCannons();
	protected :
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CBigBoot : public CWeapon
{
	public :
		CBigBoot();
};

class CSniperClub : public CWeapon
{
	public :
		CSniperClub();
};

class CMachineGun : public CWeapon
{
	public :
		CMachineGun();
};

class CRocketLauncher : public CWeapon
{
	public :
		CRocketLauncher();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};


// On-foot weapons...

class CColt45 : public CWeapon
{
	public :
		CColt45();

};

class CShotgun : public CWeapon
{
	public :
		CShotgun();
};

class CMac10 : public CWeapon
{
	public :
		CMac10();
};

class CAssaultRifle : public CWeapon
{
	public :
		CAssaultRifle();
};

class CEnergyGrenade : public CWeapon
{
	public :
		CEnergyGrenade();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CBombs : public CWeapon
{
	public :
		CBombs();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CTOW : public CWeapon
{
	public :
		CTOW();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CAutoCannons : public CWeapon
{
	public :
		CAutoCannons();

	protected : 
		CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CKatoGrenade : public CWeapon
{
	public :
		CKatoGrenade();
	protected :
		virtual CProjectile* CreateProjectile(ObjectCreateStruct & theStruct);
};

class CRamset : public CWeapon
{
	public :
		CRamset();
};

class CSqueakyToy : public CWeapon
{
	public :
		CSqueakyToy();
};

#endif // __RIOT_WEAPONS_H__
